VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSoundBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' // clsSoundBuffer.cls - class for accumulation of sound data
' //  Krivous Anatoly Anatolevich (The trick), 2016

Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)
                    
Private mBuffer()   As Byte
Private mCount      As Long
Private mMaxCount   As Long

Public Property Get SizeOfBuffer() As Long
    SizeOfBuffer = mCount
End Property

Public Sub Clear()

    Erase mBuffer()
    mCount = 0
    mMaxCount = 0
    
End Sub

Public Function AddToBuffer( _
                ByVal lpRawData As Long, _
                ByVal szCount As Long) As Boolean
    
    On Error GoTo error_handler
    
    If szCount = 0 Then Exit Function
    
    If mCount + szCount > mMaxCount Then
        
        mMaxCount = mCount + szCount + 4096
        ReDim Preserve mBuffer(mMaxCount)
        
    End If
    
    CopyMemory mBuffer(mCount), ByVal lpRawData, szCount
    mCount = mCount + szCount
    
    AddToBuffer = True
    
error_handler:
    
End Function

Public Function Extract( _
                ByVal lpTo As Long, _
                ByVal szCount As Long) As Boolean
                    
    If szCount > mCount Then Exit Function
    
    CopyMemory ByVal lpTo, mBuffer(0), szCount
    
End Function

